******************************************************************************
******************************************************************************
**                                                                          **
** ***************                   ***********                            **
**   **        ***                     **       **                          **
**   **          *                     **        **                         **
**   **                                **        **                         **
**   **          ***    *****  *****   **       **  ***   ****      ***     **
**   ******    **   **    **    **     *********      ** **   **  **   **   **
**   **       **     **    **  **      **             ***        **     **  **
**   **      **       **    ***        **             **        **       ** **
**   **       **     **    ** **       **             **         **     **  **
**   **        **   **    **   **      **             **          **   **   **
** *******       ***    *****  ****  ******         ******          ***     **
**                                                                          **
******************************************************************************
******************************************************************************

******************************************************************************
******************************************************************************
**                                                                          **
** Visual FoxPro Named Constant File                                        **
** This file contains named constants for most Visual FoxPro functions      **
**                                                                          **
******************************************************************************
******************************************************************************

*-- General

*-- DragOver
#DEFINE DRAG_ENTER          0
#DEFINE DRAG_LEAVE          1
#DEFINE DRAG_OVER           2

*-- Drag (controls)
#DEFINE DRAG_CANCEL         0
#DEFINE DRAG_BEGIN          1
#DEFINE DRAG_END            2

*--ZOrder Method
#DEFINE ZORDER_BRINGTOFRONT 0
#DEFINE ZORDER_SENDTOBACK   1

*-- TYPE() tags
#DEFINE T_CHARACTER     'C'
#DEFINE T_NUMERIC       'N'
#DEFINE T_DOUBLE        'B'
#DEFINE T_DATE          'D'
#DEFINE T_DATETIME      'T'
#DEFINE T_MEMO          'M'
#DEFINE T_GENERAL       'G'
#DEFINE T_OBJECT        'O'
#DEFINE T_SCREEN        'S'
#DEFINE T_LOGICAL       'L'
#DEFINE T_CURRENCY      'Y'
#DEFINE T_UNDEFINED     'U'

*-- QueryUnload
#DEFINE FORM_CONTROLMENU 0
#DEFINE FORM_CODE        1
#DEFINE APP_WINDOWS      2
#DEFINE APP_TASKMANAGER  3
#DEFINE FORM_MDIFORM     4

*-- Properties

*-- Colors
#DEFINE COLOR_WHITE        16777215
#DEFINE COLOR_BLACK               0
#DEFINE COLOR_GRAY         12632256
#DEFINE COLOR_DARK_GRAY     8421504
#DEFINE COLOR_RED               255
#DEFINE COLOR_DARK_BLUE     8388608
#DEFINE COLOR_CYAN         16776960
#DEFINE COLOR_DARK_CYAN     8421376
#DEFINE COLOR_GREEN           65280
#DEFINE COLOR_DARK_GREEN      32768
#DEFINE COLOR_YELLOW          65535
#DEFINE COLOR_DARK_YELLOW     32896
#DEFINE COLOR_BLUE         16711680
#DEFINE COLOR_DARK_RED          128
#DEFINE COLOR_MAGENTA      16711935
#DEFINE COLOR_DARK_MAGENTA  8388736

*-- MousePointer
#DEFINE MOUSE_DEFAULT                0   && Default
#DEFINE MOUSE_ARROW                  1   && Arrow
#DEFINE MOUSE_CROSSHAIR              2   && Cross
#DEFINE MOUSE_IBEAM                  3   && I-Beam
#DEFINE MOUSE_ICON_POINTER           4   && Icon
#DEFINE MOUSE_SIZE_POINTER           5   && Size
#DEFINE MOUSE_SIZE_NE_SW             6   && Size NE SW
#DEFINE MOUSE_SIZE_N_S               7   && Size N S
#DEFINE MOUSE_SIZE_NW_SE             8   && Size NW SE
#DEFINE MOUSE_SIZE_W_E               9   && Size W E
#DEFINE MOUSE_UP_ARROW              10   && Up Arrow
#DEFINE MOUSE_HOURGLASS             11   && Hourglass
#DEFINE MOUSE_NO_DROP               12   && No drop
#DEFINE MOUSE_HAND                  15   && Hand

*-- DragMode
#DEFINE DRAG_MANUAL                  0   && Manual
#DEFINE DRAG_AUTOMATIC               1   && Automatic

*-- DrawMode
#DEFINE DRAWMODE_BLACKNESS           1   && Blackness
#DEFINE DRAWMODE_NOT_MERGE_PEN       2   && Not Merge Pen
#DEFINE DRAWMODE_MASK_NOT_PEN        3   && Mask Not Pen
#DEFINE DRAWMODE_NOT_COPY_PEN        4   && Not Copy Pen
#DEFINE DRAWMODE_MASK_PEN_NOT        5   && Mask Pen Not
#DEFINE DRAWMODE_INVERT              6   && Invert
#DEFINE DRAWMODE_XOR_PEN             7   && Xor Pen
#DEFINE DRAWMODE_NOT_MASK_PEN        8   && Not Mask Pen
#DEFINE DRAWMODE_MASK_PEN            9   && Mask Pen
#DEFINE DRAWMODE_NOT_XOR_PEN        10   && Not Xor Pen
#DEFINE DRAWMODE_NOP                11   && Nop
#DEFINE DRAWMODE_MERGE_NOT_PEN      12   && Merge Not Pen
#DEFINE DRAWMODE_COPY_PEN           13   && Copy Pen
#DEFINE DRAWMODE_MERGE_PEN_NOT      14   && Merge Pen Not
#DEFINE DRAWMODE_MERGE_PEN          15   && Merge Pen
#DEFINE DRAWMODE_WHITENESS          16   && Whiteness

*-- DrawStyle
#DEFINE DRAWSTYLE_SOLID              0   && Solid
#DEFINE DRAWSTYLE_DASH               1   && Dash
#DEFINE DRAWSTYLE_DOT                2   && Dot
#DEFINE DRAWSTYLE_DASH_DOT           3   && Dash-Dot
#DEFINE DRAWSTYLE_DASH_DOT_DOT       4   && Dash-Dot-Dot
#DEFINE DRAWSTYLE_INVISIBLE          5   && Invisible
#DEFINE DRAWSTYLE_INSIDE_SOLID       6   && Inside Solid

*-- FillStyle
#DEFINE FILLSTYLE_SOLID              0   && Solid
#DEFINE FILLSTYLE_TRANSPARENT        1   && Transparent
#DEFINE FILLSTYLE_HORIZONTAL_LINE    2   && Horizontal Line
#DEFINE FILLSTYLE_VERTICAL_LINE      3   && Vertical Line
#DEFINE FILLSTYLE_UPWARD_DIAGONAL    4   && Upward Diagonal
#DEFINE FILLSTYLE_DOWNWARD_DIAGONAL  5   && Downward Diagonal
#DEFINE FILLSTYLE_CROSS              6   && Cross
#DEFINE FILLSTYLE_DIAGONAL_CROSS     7   && Diagonal Cross

*-- ScaleMode
#DEFINE SCALEMODE_PIXELS             3   && Pixel
#DEFINE SCALEMODE_FOXELS             0   && Foxels

*-- WindowState
#DEFINE WINDOWSTATE_NORMAL           0   && Normal
#DEFINE WINDOWSTATE_MINIMIZED        1   && Minimized
#DEFINE WINDOWSTATE_MAXIMIZED        2   && Maximized

*-- Window Borders
#DEFINE BORDER_NONE     0
#DEFINE BORDER_SINGLE   1
#DEFINE BORDER_DOUBLE   2
#DEFINE BORDER_SYSTEM   3

*-- Button parameter masks
#DEFINE BUTTON_LEFT     1
#DEFINE BUTTON_RIGHT    2
#DEFINE BUTTON_MIDDLE   4

*-- Shift state masks
#DEFINE NOKEYS_PRESSED  0
#DEFINE SHIFT_PRESSED   1
#DEFINE CTRL_PRESSED    2
#DEFINE ALT_PRESSED     4

*-- Toolbar Positions
#DEFINE TOOL_NOTDOCKED -1
#DEFINE TOOL_TOP        0
#DEFINE TOOL_LEFT       1
#DEFINE TOOL_RIGHT      2
#DEFINE TOOL_BOTTOM     3

*-- Visual FoxPro toolbar names
#DEFINE TB_FORMDESIGNER "Form Designer"
#DEFINE TB_STANDARD     "Standard"
#DEFINE TB_LAYOUT       "Layout"
#DEFINE TB_QUERY        "Query Designer"
#DEFINE TB_VIEWDESIGNER "View Designer"
#DEFINE TB_COLORPALETTE "Color Palette"
#DEFINE TB_FORMCONTROLS "Form Controls"
#DEFINE TB_DATADESIGNER "Database Designer"
#DEFINE TB_REPODESIGNER "Report Designer"
#DEFINE TB_REPOCONTROLS "Report Controls"
#DEFINE TB_PRINTPREVIEW "Print Preview"

*-- Function Parameters

*-- MessageBox parameters
#DEFINE MB_OK                   0     && OK button only
#DEFINE MB_OKCANCEL             1     && OK and Cancel buttons
#DEFINE MB_ABORTRETRYIGNORE     2     && Abort, Retry, and Ignore buttons
#DEFINE MB_YESNOCANCEL          3     && Yes, No, and Cancel buttons
#DEFINE MB_YESNO                4     && Yes and No buttons
#DEFINE MB_RETRYCANCEL          5     && Retry and Cancel buttons

#DEFINE MB_ICONSTOP            16     && Critical message
#DEFINE MB_ICONQUESTION        32     && Warning query
#DEFINE MB_ICONEXCLAMATION     48     && Warning message
#DEFINE MB_ICONINFORMATION     64     && Information message

#DEFINE MB_APPLMODAL            0     && Application modal message box
#DEFINE MB_DEFBUTTON1           0     && First button is default
#DEFINE MB_DEFBUTTON2         256     && Second button is default
#DEFINE MB_DEFBUTTON3         512     && Third button is default
#DEFINE MB_SYSTEMMODAL       4096     && System Modal

*-- MessageBox return values
#DEFINE IDOK                    1     && OK button pressed
#DEFINE IDCANCEL                2     && Cancel button pressed
#DEFINE IDABORT                 3     && Abort button pressed
#DEFINE IDRETRY                 4     && Retry button pressed
#DEFINE IDIGNORE                5     && Ignore button pressed
#DEFINE IDYES                   6     && Yes button pressed
#DEFINE IDNO                    7     && No button pressed


*-- Low Level File Constants
#DEFINE F_READONLY              0
#DEFINE F_WRITEONLY             1
#DEFINE F_READWRITE             2
#DEFINE F_READONLY_UNBUFF      10
#DEFINE F_WRITEONLY_UNBUFF     11
#DEFINE F_READWRITE_UNBUFF     12

*-- PRTINFO() Constants
*-- PRTINFO() Valid types to pass
#DEFINE PRT_ORIENTATION         1
#DEFINE PRT_PAPERSIZE           2
#DEFINE PRT_PAPERLENGTH         3
#DEFINE PRT_PAPERWIDTH          4
#DEFINE PRT_SCALE               5
#DEFINE PRT_COPIES              6
#DEFINE PRT_DEFASOURCE          7
#DEFINE PRT_PRINTQUAL           8
#DEFINE PRT_COLOR               9
#DEFINE PRT_DUPLEX             10
#DEFINE PRT_YRESOLUTION        11
#DEFINE PRT_TTOPTION           12

*--PRTINFO() Return types
*-- Paper sizes
#DEFINE PRTPAPER_LETTER              1 && Letter 8 1/2 x 11 in
#DEFINE PRTPAPER_LETTERSMALL         2 && Letter Small 8 1/2 x 11 in
#DEFINE PRTPAPER_TABLOID             3 && Tabloid 11 x 17 in
#DEFINE PRTPAPER_LEDGER              4 && Ledger 17 x 11 in
#DEFINE PRTPAPER_LEGAL               5 && Legal 8 1/2 x 14 in
#DEFINE PRTPAPER_STATEMENT           6 && Statement 5 1/2 x 8 1/2 in
#DEFINE PRTPAPER_EXECUTIVE           7 && Executive 7 1/4 x 10 1/2 in
#DEFINE PRTPAPER_A3                  8 && A3 297 x 420 mm
#DEFINE PRTPAPER_A4                  9 && A4 210 x 297 mm
#DEFINE PRTPAPER_A4SMALL            10 && A4 Small 210 x 297 mm
#DEFINE PRTPAPER_A5                 11 && A5 148 x 210 mm
#DEFINE PRTPAPER_B4                 12 && B4 250 x 354
#DEFINE PRTPAPER_B5                 13 && B5 182 x 257 mm
#DEFINE PRTPAPER_FOLIO              14 && Folio 8 1/2 x 13 in
#DEFINE PRTPAPER_QUARTO             15 && Quarto 215 x 275 mm
#DEFINE PRTPAPER_10X14              16 && 10x14 in
#DEFINE PRTPAPER_11X17              17 && 11x17 in
#DEFINE PRTPAPER_NOTE               18 && Note 8 1/2 x 11 in
#DEFINE PRTPAPER_ENV_9              19 && Envelope #9 3 7/8 x 8 7/8
#DEFINE PRTPAPER_ENV_10             20 && Envelope #10 4 1/8 x 9 1/2
#DEFINE PRTPAPER_ENV_11             21 && Envelope #11 4 1/2 x 10 3/8
#DEFINE PRTPAPER_ENV_12             22 && Envelope #12 4 \276 x 11
#DEFINE PRTPAPER_ENV_14             23 && Envelope #14 5 x 11 1/2
#DEFINE PRTPAPER_CSHEET             24 && C size sheet
#DEFINE PRTPAPER_DSHEET             25 && D size sheet
#DEFINE PRTPAPER_ESHEET             26 && E size sheet
#DEFINE PRTPAPER_ENV_DL             27 && Envelope DL 110 x 220mm
#DEFINE PRTPAPER_ENV_C5             28 && Envelope C5 162 x 229 mm
#DEFINE PRTPAPER_ENV_C3             29 && Envelope C3  324 x 458 mm
#DEFINE PRTPAPER_ENV_C4             30 && Envelope C4  229 x 324 mm
#DEFINE PRTPAPER_ENV_C6             31 && Envelope C6  114 x 162 mm
#DEFINE PRTPAPER_ENV_C65            32 && Envelope C65 114 x 229 mm
#DEFINE PRTPAPER_ENV_B4             33 && Envelope B4  250 x 353 mm
#DEFINE PRTPAPER_ENV_B5             34 && Envelope B5  176 x 250 mm
#DEFINE PRTPAPER_ENV_B6             35 && Envelope B6  176 x 125 mm
#DEFINE PRTPAPER_ENV_ITALY          36 && Envelope 110 x 230 mm
#DEFINE PRTPAPER_ENV_MONARCH        37 && Envelope Monarch 3.875 x 7.5 in
#DEFINE PRTPAPER_ENV_PERSONAL       38 && 6 3/4 Envelope 3 5/8 x 6 1/2 in
#DEFINE PRTPAPER_FANFOLD_US         39 && US Std Fanfold 14 7/8 x 11 in
#DEFINE PRTPAPER_FANFOLD_STD_GERMAN 40 && German Std Fanfold 8 1/2 x 12 in
#DEFINE PRTPAPER_FANFOLD_LGL_GERMAN 41 && German Legal Fanfold 8 1/2 x 13 in

*-- Paper bins
#DEFINE PRTBIN_UPPER          1
#DEFINE PRTBIN_ONLYONE        1
#DEFINE PRTBIN_LOWER          2
#DEFINE PRTBIN_MIDDLE         3
#DEFINE PRTBIN_MANUAL         4
#DEFINE PRTBIN_ENVELOPE       5
#DEFINE PRTBIN_ENVMANUAL      6
#DEFINE PRTBIN_AUTO           7
#DEFINE PRTBIN_TRACTOR        8
#DEFINE PRTBIN_SMALLFMT       9
#DEFINE PRTBIN_LARGEFMT      10
#DEFINE PRTBIN_LARGECAPACITY 11
#DEFINE PRTBIN_CASSETTE      14

*-- Print qualities
#DEFINE PRTRES_DRAFT       -1
#DEFINE PRTRES_LOW         -2
#DEFINE PRTRES_MEDIUM      -3
#DEFINE PRTRES_HIGH        -4

*-- Color printer
#DEFINE PRTCOLOR_MONOCHROME 1
#DEFINE PRTCOLOR_COLOR      2

*-- Duplexing
#DEFINE PRTDUP_SIMPLEX      1
#DEFINE PRTDUP_VERTICAL     2
#DEFINE PRTDUP_HORIZONTAL   3

*-- True Type fonts
#DEFINE PRTTT_BITMAP        1 && Print True Type fonts as graphics
#DEFINE PRTTT_DOWNLOAD      2 && Download True Type fonts as soft fonts
#DEFINE PRTTT_SUBDEV        3 && Substitute device fonts for True Type

*-- FontMetric()
#DEFINE TM_HEIGHT           1
#DEFINE TM_ASCENT           2
#DEFINE TM_DESCENT          3
#DEFINE TM_INTERNALLEADING  4
#DEFINE TM_EXTERNALLEADING  5
#DEFINE TM_AVECHARWIDTH     6
#DEFINE TM_MAXCHARWIDTH     7
#DEFINE TM_WEIGHT           8
#DEFINE TM_ITALIC           9
#DEFINE TM_UNDERLINED      10
#DEFINE TM_STRUCKOUT       11
#DEFINE TM_FIRSTCHAR       12
#DEFINE TM_LASTCHAR        13
#DEFINE TM_DEFAULTCHAR     14
#DEFINE TM_BREAKCHAR       15
#DEFINE TM_PITCHANDFAMILY  16
#DEFINE TM_CHARSET         17
#DEFINE TM_OVERHANG        18
#DEFINE TM_ASPECTX         19
#DEFINE TM_ASPECTY         20

*-- SysMetric()
#DEFINE SM_CXSCREEN       1 && Screen width
#DEFINE SM_CYSCREEN       2 && Screen height.
#DEFINE SM_CXSIZE         3 && Width of sizable window frame
#DEFINE SM_CYSIZE         4 && Height of sizable window frame
#DEFINE SM_CXVSCROLL      5 && Width of scroll arrows on vertical scroll bar
#DEFINE SM_CYVSCROLL      6 && Height of scroll arrows on vertical scroll bar
#DEFINE SM_CXHSCROLL      7 && Width of scroll arrows on horizontal scroll bar
#DEFINE SM_CYHSCROLL      8 && Height of scroll arrows on horizontal scroll bar
#DEFINE SM_CYCAPTION      9 && Height of window title
#DEFINE SM_CXFRAME       10 && Width of non-sizable window frame
#DEFINE SM_CYFRAME       11 && Height of non-sizable window frame
#DEFINE SM_CXDLGFRAME    12 && Width of DOUBLE or PANEL window frame
#DEFINE SM_CYDLGFRAME    13 && Height of DOUBLE or PANEL window frame
#DEFINE SM_CXHTHUMB      14 && Scroll box width on horizontal scroll bar in text editing windows
#DEFINE SM_CYVTHUMB      15 && Scroll box height on vertical scroll bar in text editing windows
#DEFINE SM_CXICON        16 && Minimized window icon width
#DEFINE SM_CYICON        17 && Minimized window icon height
#DEFINE SM_CXCURSOR      18 && Maximum insertion point width
#DEFINE SM_CYCURSOR      19 && Maximum insertion point height
#DEFINE SM_CYMENU        20 && Single-line menu bar height
#DEFINE SM_CXFULLSCREEN  21 && Maximized window width
#DEFINE SM_CYFULLSCREEN  22 && Maximized window height
#DEFINE SM_CYKANJIWINDOW 23 && Kanji window height
#DEFINE SM_CXSIZEMIN     24 && Minimum sizable window width
#DEFINE SM_CYSIZEMIN     25 && Minimum sizable window height
#DEFINE SM_CXMIN         26 && Minimum window width
#DEFINE SM_CYMIN         27 && Minimum window height
#DEFINE SM_CXCONTROL     28 && Window controls width
#DEFINE SM_CYCONTROL     29 && Window controls height
#DEFINE SM_MOUSEPRESENT  30 && 1 if mouse hardware present; otherwise 0
#DEFINE SM_DEBUG         31 && 1 for Microsoft Windows debugging version; otherwise 0
#DEFINE SM_SWAPBUTTON    32 && 1 if mouse buttons swapped; otherwise 0
#DEFINE SM_CXMINTRACK    33
#DEFINE SM_CYMINTRACK    34

*-- Cursor buffering modes
#DEFINE DB_BUFOFF           1
#DEFINE DB_BUFLOCKRECORD    2
#DEFINE DB_BUFOPTRECORD     3
#DEFINE DB_BUFLOCKTABLE     4
#DEFINE DB_BUFOPTTABLE      5

*-- Update types for views/cursors
#DEFINE DB_UPDATE           1
#DEFINE DB_DELETEINSERT     2

*-- WHERE clause types for views/cursors
#DEFINE DB_KEY              1
#DEFINE DB_KEYANDUPDATABLE  2
#DEFINE DB_KEYANDMODIFIED   3
#DEFINE DB_KEYANDTIMESTAMP  4

*-- Remote connection login prompt options
#DEFINE DB_PROMPTCOMPLETE   1
#DEFINE DB_PROMPTALWAYS     2
#DEFINE DB_PROMPTNEVER      3

*-- Remote transaction modes
#DEFINE DB_TRANSAUTO        1
#DEFINE DB_TRANSMANUAL      2

*-- Source Types for CursorGetProp()
#DEFINE DB_SRCLOCALVIEW     1
#DEFINE DB_SRCREMOTEVIEW    2
#DEFINE DB_SRCTABLE         3

*-- Long Win95/NT filenames

#DEFINE NOTVALIDNAMECHARS  '\/:*?"<>|'
#DEFINE MAX_FILENAMELEN    255

*-- Misc constants

#DEFINE CR    CHR(13)
#DEFINE CRLF  CHR(13)+CHR(10)
#DEFINE HTAB  CHR(9)
#DEFINE SP    CHR(32)

#DEFINE TRUE  .T.
#DEFINE FALSE .F.
#DEFINE NULL  .NULL.

*-- Constants used to read the system registry
#DEFINE HKEY_LOCAL_MACHINE         -2147483646
#DEFINE KEY_SHARED_TOOLS_LOCATION  "Software\Microsoft\Shared Tools Location"
#DEFINE KEY_WIN4CURRENTVERSION    "Software\Microsoft\Windows\CurrentVersion"
#DEFINE KEY_NTCURRENTVERSION   "Software\Microsoft\Windows NT\CurrentVersion"
#DEFINE KEY_QUERY_VALUE        1
#DEFINE ERROR_SUCCESS          0

*-- Constants to identify which trigger failed
*-- using element 5 of the array returned by AERROR(),
*-- as well as to reference the appropriate array
*-- element in the error message array: aErrorMsg[]
#DEFINE INSERTTRIG  1
#DEFINE UPDATETRIG  2
#DEFINE DELETETRIG  3

#DEFINE NORMAL_PRIORITY_CLASS 32
#DEFINE IDLE_PRIORITY_CLASS 64
#DEFINE HIGH_PRIORITY_CLASS 128
#DEFINE REALTIME_PRIORITY_CLASS 1600
#DEFINE CREATE_NO_WINDOW 134217728

*-- Return code from WaitForSingleObject() if it timed out.
#DEFINE WAIT_TIMEOUT 0x00000102

*-- Error codes
#DEFINE ERROR_USERDEFINED    1098

*-- Predefined Clipboard Formats
#DEFINE CF_TEXT             1
#DEFINE CF_BITMAP           2
#DEFINE CF_METAFILEPICT     3
#DEFINE CF_SYLK             4
#DEFINE CF_DIF              5
#DEFINE CF_TIFF             6
#DEFINE CF_OEMTEXT          7
#DEFINE CF_DIB              8
#DEFINE CF_PALETTE          9
#DEFINE CF_PENDATA          10
#DEFINE CF_RIFF             11
#DEFINE CF_WAVE             12
#DEFINE CF_UNICODETEXT      13
#DEFINE CF_ENHMETAFILE      14

*-- Menus setting
#DEFINE MAXMENU             37  && Must be more than 26

#INCLUDE FOXPRO.STR
