* -----------------------------
* Measurement form include file
* -----------------------------

#INCLUDE FOXPRO.H
#INCLUDE MISC.H

*#DEFINE FKEYBARUSED         .T.
*#DEFINE LOCKEDTOOLBARSUSED  .T.
*#DEFINE GETSAVEFORMINFOUSED .T.
*#DEFINE OBJAPPFRAMEWORKUSED .T.

*---------------------
*-- Measure unit codes

#DEFINE MEASURE_SCALAR [001]   && Dimensionless quantities
#DEFINE MEASURE_VECTOR [002]   && Vector values
#DEFINE MEASURE_PT     [011]   && Points
#DEFINE MEASURE_MM     [012]   && Milimeters
#DEFINE MEASURE_CM     [013]   && Centimeters
#DEFINE MEASURE_IN     [014]   && Inches
#DEFINE MEASURE_FT     [015]   && Feet
#DEFINE MEASURE_A      [016]   && Angstroms
#DEFINE MEASURE_MU     [017]   && Microns
#DEFINE MEASURE_MILL   [018]   && Linear Mils
#DEFINE MEASURE_LN     [019]   && Lines
#DEFINE MEASURE_YD     [021]   && Yards
#DEFINE MEASURE_M      [022]   && Meters
#DEFINE MEASURE_KM     [023]   && Kilometers
#DEFINE MEASURE_MILE   [024]   && Miles
#DEFINE MEASURE_INM    [025]   && International Nautical Miles
#DEFINE MEASURE_RD     [026]   && Rods
#DEFINE MEASURE_FUR    [027]   && Furlongs
#DEFINE MEASURE_FA     [028]   && Fathoms
#DEFINE MEASURE_LY     [029]   && Light Years
#DEFINE MEASURE_MM2    [031]   && Sq.milimeters
#DEFINE MEASURE_CM2    [032]   && Sq.centimeters
#DEFINE MEASURE_IN2    [033]   && Sq.inches
#DEFINE MEASURE_FT2    [034]   && Sq.feet
#DEFINE MEASURE_M2     [035]   && Sq.meters
#DEFINE MEASURE_YD2    [041]   && Sq.yards
#DEFINE MEASURE_AR     [042]   && Ares
#DEFINE MEASURE_ACR    [043]   && Acres
#DEFINE MEASURE_HA     [044]   && Hectares
#DEFINE MEASURE_KM2    [045]   && Sq.kilometers
#DEFINE MEASURE_ML     [051]   && Mililiters
#DEFINE MEASURE_PT_US  [052]   && Pints (US)
#DEFINE MEASURE_L      [053]   && Liters
#DEFINE MEASURE_GAL    [054]   && Gallons (US)
#DEFINE MEASURE_BP     [055]   && Barrels petrol
#DEFINE MEASURE_CM3    [061]   && Cub.centimeters
#DEFINE MEASURE_IN3    [062]   && Cub.inches
#DEFINE MEASURE_FT3    [063]   && Cub.feet
#DEFINE MEASURE_M3     [064]   && Cub.meters
#DEFINE MEASURE_RT     [065]   && Register tonnes
#DEFINE MEASURE_MSI    [071]   && Megapounds per sq.inch
#DEFINE MEASURE_KG_CM2 [072]   && Kilograms per sq.cm
#DEFINE MEASURE_B      [073]   && Bars
#DEFINE MEASURE_KSI    [074]   && Kilopounds per sq.inch
#DEFINE MEASURE_MPA    [075]   && Megapascals
#DEFINE MEASURE_ATM    [076]   && Atmospheres
#DEFINE MEASURE_INH2O  [077]   && Inches of water
#DEFINE MEASURE_INHG   [078]   && Inches of mercury
#DEFINE MEASURE_MMHG   [079]   && Millimeters mercury
#DEFINE MEASURE_N      [081]   && Newtons
#DEFINE MEASURE_KN     [082]   && Kilonewtons
#DEFINE MEASURE_LBF    [083]   && Pound-force
#DEFINE MEASURE_KGF    [084]   && Kilogram-force
#DEFINE MEASURE_KIP    [085]   && Kilopound-force
#DEFINE MEASURE_IN_LBF [091]   && Inch pound-force
#DEFINE MEASURE_MKF    [092]   && Meter kilogram-force
#DEFINE MEASURE_J      [093]   && Joule
#DEFINE MEASURE_FT_LBF [094]   && Foot pound-force
#DEFINE MEASURE_KWH    [095]   && Kilowatt-Hour
#DEFINE MEASURE_CAL_H  [101]   && Calorie per hour
#DEFINE MEASURE_TONS_H [102]   && Ton refriger/hour
#DEFINE MEASURE_WT     [103]   && Watts
#DEFINE MEASURE_HP     [104]   && Horse-Power
#DEFINE MEASURE_KWT    [105]   && Kilowatts
#DEFINE MEASURE_CT     [111]   && Carat
#DEFINE MEASURE_G      [112]   && Grams
#DEFINE MEASURE_OZ     [113]   && Ounces
#DEFINE MEASURE_LB     [114]   && Pounds
#DEFINE MEASURE_KG     [115]   && Kilograms
#DEFINE MEASURE_OZ_T   [116]   && Troy Ounces
#DEFINE MEASURE_CWT    [117]   && Long hundredweight
#DEFINE MEASURE_T      [118]   && Metric tons
#DEFINE MEASURE_TON    [119]   && Net (short) tons
#DEFINE MEASURE_M_S    [121]   && Meters per second
#DEFINE MEASURE_ML_H   [122]   && Miles per hour
#DEFINE MEASURE_FT_S   [123]   && Feet per second
#DEFINE MEASURE_KM_H   [124]   && Kilometers per hour
#DEFINE MEASURE_IN_M   [125]   && Inches per minute
#DEFINE MEASURE_MM_M   [126]   && Milimeters per minute
#DEFINE MEASURE_IN_S   [127]   && Inches per second
#DEFINE MEASURE_KNOT   [128]   && Knots
#DEFINE MEASURE_MA     [129]   && Mach numbers
#DEFINE MEASURE_F      [131]   && Fahrenheits
#DEFINE MEASURE_C      [132]   && Celsius
#DEFINE MEASURE_K      [133]   && Kelvins
#DEFINE MEASURE_RAD    [141]   && Radians
#DEFINE MEASURE_DEG    [142]   && Degrees
#DEFINE MEASURE_M_ARC  [143]   && Minutes of arc
#DEFINE MEASURE_S_ARC  [144]   && Seconds of arc
#DEFINE MEASURE_REV    [145]   && Revolutions
#DEFINE MEASURE_MIL    [146]   && Mils
#DEFINE MEASURE_GRAD   [147]   && Grades
#DEFINE MEASURE_CG     [148]   && Centigrades
#DEFINE MEASURE_Q_ARC  [149]   && Quadrants
#DEFINE MEASURE_MUS    [151]   && Microseconds
#DEFINE MEASURE_MS     [152]   && Milliseconds
#DEFINE MEASURE_SEC    [153]   && Seconds of time
#DEFINE MEASURE_MIN    [154]   && Minutes of time
#DEFINE MEASURE_HR     [155]   && Hours
#DEFINE MEASURE_DA     [161]   && Days
#DEFINE MEASURE_WKS    [162]   && Weeks
#DEFINE MEASURE_MO     [163]   && Months
#DEFINE MEASURE_YR     [164]   && Years
#DEFINE MEASURE_CENT   [165]   && Centuries
#DEFINE MEASURE_KG_M3  [171]   && Kilograms per cub.meter
#DEFINE MEASURE_G_M3   [172]   && Grams per cub.meter
#DEFINE MEASURE_OZ_FT3 [173]   && Ounces per cub.feet
#DEFINE MEASURE_LB_FT3 [174]   && Pounds per cub.feet
#DEFINE MEASURE_LB_IN3 [175]   && Pounds per cub.inches
#DEFINE MEASURE_SH_C   [181]   && Specific heat (C)
#DEFINE MEASURE_J_GK   [182]   && Joule per gram Kelvin
#DEFINE MEASURE_TC_K   [191]   && Thermal conductivity (K)
#DEFINE MEASURE_W_MK   [192]   && Watt per meter Kelvin
#DEFINE MEASURE_IN_INF [201]   && Inch per inch Fahrenheit
#DEFINE MEASURE_M_MK   [202]   && Meter per meter Kelvin
#DEFINE MEASURE_D      [211]   && Dollars
#DEFINE MEASURE_D_HR   [212]   && Dollars per Hour
#DEFINE MEASURE_D_LB   [213]   && Dollars per Pound
#DEFINE MEASURE_D_FT2  [214]   && Dollars per sq.feet
#DEFINE MEASURE_KDOL   [215]   && Thousand Dollars
#DEFINE MEASURE_MDOL   [216]   && Million Dollars
#DEFINE MEASURE_D_WKS  [217]   && Dollars per Week
#DEFINE MEASURE_D_MO   [218]   && Dollars per Month
#DEFINE MEASURE_D_YR   [219]   && Dollars per Year

*-------------------
*-- Numerical limits

#DEFINE PAGE_ELEMENT_MAX   9
#DEFINE MAXSIZE            15

*----------------------------------------------
*-- Some measurement units conversion constants

#DEFINE INTOMM        25.4
#DEFINE MMTOIN        0.03937
#DEFINE MMTOFT        3.281E-3
#DEFINE CMTOIN        0.3937
#DEFINE CMTOFT        3.281E-2
#DEFINE  MTOIN        39.37
#DEFINE  MTOFT        3.281

#DEFINE LBTOKN        0.004448221615

#DEFINE MPATOKSI      0.145037737
#DEFINE MPATOMSI      0.000145037737
#DEFINE MPATOKGCM2    10.19716213
#DEFINE GPATOKSI      145.037737
#DEFINE GPATOMSI      0.145037737
#DEFINE GPATOKGCM2    10197.16213
#DEFINE KSITOMPA      6.894757293
#DEFINE KSITOGPA      0.006894757293
#DEFINE MSITOMPA      6894.757293
#DEFINE MSITOGPA      6.894757293
#DEFINE KGCM2TOMPA    0.0980665
#DEFINE KGCM2TOGPA    0.0000980665

#DEFINE CONST_MPA     6.894757293
#DEFINE JOULE         0.112984829
