*-------------------------------------------
*--
*-- Runtime Mode Application Startup Program
*--
*-- Entry point for front-end application
*--
*-------------------------------------------

*-- Include
#INCLUDE foxpro.h	&& !!!@@@

*-- Clear all at first
CLEAR
CLEAR DLLS
RELEASE ALL EXTENDED
CLEAR ALL

PUBLIC DEBUGMODE  && TRUE when running within VFP, FALSE for standalone program
PUBLIC gcHomePath && Working directory

*-- DECLARE DLL statements for the temporary directory
DECLARE INTEGER GetTempPath IN Win32API ;
  INTEGER nBufSize, STRING @lpszTemPath
PUBLIC gcTemPath  && Temporary directory

*-- DECLARE DLL statements for the copying an existing file to a new file
DECLARE INTEGER CopyFile IN Win32API ;
  STRING @lpExistingFileName, ;
  STRING @lpNewFileName, INTEGER bFailIfExists          

*-- DECLARE DLL statement for beeping
DECLARE INTEGER MessageBeep IN Win32API AS MsgBeep Integer sound

*-- Set up the path so we can instantiate the application object
IF SetPath()
  *-- Init startup and message loop
  DO FORM MAIN
  READ EVENTS
ENDIF

*-- If inside VFP run Project Manager again
IF DEBUGMODE
  ACTIVATE WINDOW "Project Manager"
ENDIF

*-- Clear all at exit
CLEAR DLLS
RELEASE ALL EXTENDED
CLEAR ALL

*-- End of program
*--------------------------------------------

*--------------------------------------------
*-- Set path to application working directory
*--------------------------------------------
FUNCTION SetPath()
*-----------------
  LOCAL lcPath, lcBuffer
  LOCAL lnStart

  lcPath = SYS(16)                              && Where we were executed...
  lnStart = AT("\\", lcPath)

  IF lnStart = 0
    lnStart = AT(":", lcPath) - 1
  ENDIF

  IF lnStart > 0
    lcPath = SUBSTR(lcPath, lnStart)            && Derive program name
  ENDIF

  gcHomePath = LEFT(lcPath, RAT("\", lcPath))   && ... and path to it

  *-- Change current directory to working...
  CD (gcHomePath)

  *-- If we are running MAIN.PRG directly, then
  *-- CD up to the parent directory
  IF RIGHT(lcPath, 3) = "FXP"
    *-- One level up
    CD ..

    *-- Assume we were run from VFP
    DEBUGMODE  = TRUE

    *-- Make out path to INI file
    gcHomePath = LEFT(gcHomePath, RAT("\", gcHomePath, 2))

    *-- Ensure the project manager is closed
    DEACTIVATE WINDOW "Project Manager"
  ENDIF

  *-- Set all pathes
  SET DEFAULT   TO (gcHomePath)
	SET PATH      TO Classes, Forms, Includes, Menus, Pictures, Procs, Database, Scripts
  SET PROCEDURE TO Measure
  SET CLASSLIB  TO && !!!@@@

  *-- Temporary path
  lcBuffer = REPL(' ', 511) + CHR(0)
  lnStart  = GetTempPath(512, @lcBuffer)

  IF lnStart > 0
    gcTemPath = LEFT(lcBuffer, lnStart)
  ELSE
    gcTemPath = gcHomePath
  ENDIF

  IF RIGHT(gcTemPath, 1) <> '\'
    gcTemPath = gcTemPath + '\'
  ENDIF

  RETURN TRUE

ENDFUNC
