*--------------------------------------------------------
*--
*-- Project Clean-Up Program
*--
*-- Should be started after the project is only opened or
*-- any clean-up actions are needed.
*--
*--------------------------------------------------------

*-- First clean up application that are currently being run
IF TYPE('oApp') = 'O'
  IF oApp.Cleanup()
    oApp.Cleanup2()
  ENDIF
ENDIF

*-- Close all files and databases
CLEAR ALL
CLOSE DATABASES ALL
_screen.MousePointer = 0

*-- Set project path to specified folder (emulate 'chroot' in UNIX)
PUBLIC g_cProjectHome

= SetProjectPath()

*-- Set all local defaults

*-- Now... in project home directory
CD (g_cProjectHome)

*----------------------------------------------------------------------------
*-- Set all pathes (to FORMS, CLASSES, PROGRAMS, etc.)
SET DEFAULT   TO (g_cProjectHome)
SET PATH      TO Classes, Forms, Includes, Menus, Pictures, Procs, Database, Scripts
SET PROCEDURE TO Measure
SET CLASSLIB  TO && !!!@@@ 
*----------------------------------------------------------------------------

*-- Do not update VFP settings when Windows updates its own
SET SYSFORMATS OFF
*-- All years > 80 without century digits will be considered as 19.. century
SET CENTURY TO 19 ROLLOVER 80
*-- Month-Day-Year date format
SET DATE USA
*-- 2*12 hours in a day
SET HOURS TO 12
*-- Default mark for decimal point "."
SET POINT TO
*-- Set default collate
SET COLLATE TO "MACHINE"
*-- Open DB non-exclusive (shared open)
SET EXCLUSIVE OFF

*-- Open local database (!!! project depended !!!)
OPEN DATABASE DATABASE\Sample

*-- Release some stuff
RELEASE g_cProjectHome

*-- End of program
*---------------------------------------------------------

*------------------------------------------------
*-- Set path to project home
*-- Get current file location as \<HOME>\Programs
*------------------------------------------------
PROCEDURE SetProjectPath()
  LOCAL lnStart
  LOCAL lcPath

  lcPath  = SYS(16)
  lnStart = AT("\\", lcPath)

  IF lnStart = 0
    lnStart = AT(":", lcPath) - 1
  ENDIF

  IF lnStart > 0
    lcPath = SUBSTR(lcPath, lnStart)
  ENDIF

  g_cProjectHome = LEFT(lcPath, RAT("\", lcPath, 2) - 1)

ENDPROC